#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <cstdio>
#include "wave.h"

#define TimePerSecond 1000.0

using namespace std;
struct ly{
  double time;
  string words;
  int weight[100];
};
void printlong(unsigned long forout){
  unsigned char realout[4];
  memcpy(realout,&forout,4);
  cout << realout[0]<<realout[1]<<realout[2]<<realout[3];
}
void printshort(short sam2){
  unsigned char realout[2];
  memcpy(realout,&sam2,2);
  cout << realout[0]<<realout[1];
}
int outformat;
int main(int argc,char**  argv){
  if (argc<4){
    cout << "Usage:\n\t./convert wavefile lyfile format(1=human,2=machine)" << endl;
    exit(1);
  }
  vector<ly> myly;

  ifstream flyin(argv[2]);
  double timelenth=1.0;
  unsigned totallen=0;
  outformat=atoi(argv[3]);
 
  ly temp;
  
   while(!flyin.eof() ){
    flyin >> temp.time;
    if (temp.time==0.0)
      break;
    
    getline(flyin,temp.words);
    getline(flyin,temp.words);
    if (temp.words.length()==0 || temp.words.length()>100){
      getline(flyin,temp.words);
      continue;
    }
    
    for(int i=0;i<temp.words.length();i++){
      flyin >> temp.weight[i];
      if (outformat==1)
	cout << temp.weight[i] << " ";
    }
    if (outformat==1)
      cout << endl;
    
    totallen+=temp.words.length();
   
    myly.push_back(temp);
  }
  flyin.close();

    
  WaveFile mywav;
  mywav.OpenRead(argv[1]);

  if (outformat==1){
    cout << "Number of Sample:" <<mywav.GetNumSamples() << endl;
    cout << "Bits per channel:" <<mywav.GetBitsPerChannel() << endl;
    cout << "Bytes per Sample:" <<mywav.GetBytesPerSample() << endl;
    cout << "Sample Rate:" << mywav.GetSampleRate() << endl;
    cout << "Byte per second:" << mywav.GetBytesPerSecond() << endl;
  }


  
  /*
    now print the length of total ly
  */
  unsigned long outlen=mywav.GetNumSamples()*mywav.GetBytesPerSample();

  if (outformat==1){
    cout << endl << "Len:" << totallen << endl;
    printf("(0x%X)\n",totallen);
  }
  else
    printlong(totallen);

  if (outformat==1){
    cout << "Total length:" << outlen ;
    printf("(0x%X)\n",outlen);
  }
  else
    printlong(outlen);



  for(int i=0;i<myly.size();i++){
    double totaltime=myly[i].time;
    int wordlen=myly[i].words.length();
    int totalweight=0;
    for(int j=0;j<wordlen;j++)
      totalweight+=myly[i].weight[j];
    double timeperweight=totaltime/(double)totalweight;
    for(int j=0;j<wordlen;j++){
      unsigned long forout=(long)(timeperweight*myly[i].weight[j]*((double)mywav.GetBytesPerSecond()/16.0));
      if (outformat==1){
	cout << "Time:" << forout ;
	printf("(0x%X) %c\n",forout,myly[i].words.at(j));
      }else{
	printlong(forout);
	cout << myly[i].words.at(j);
      }
    }
  }
  


  
  unsigned char sam1;
  short sam2;
  
  for(long i=0;i<mywav.GetNumSamples();i++){
    if (mywav.GetBytesPerSample()==1){
      mywav.ReadSample(sam1);
      if (outformat==1)
	cout << "1";
      else
	cout << sam1;
    }else{
      mywav.ReadSample(sam2);
      if (outformat==1)
	cout << "2" ;
      else
	printshort(sam2);
      
    }

  }
  mywav.Close();
  
  return 0;
}
